### Virtual Method

# WPEPlatform Keymap translate_keyboard_state

#### Declaration [src]

    gboolean
    translate_keyboard_state (
      WPEKeymap* keymap,
      guint keycode,
      WPEModifiers modifiers,
      int group,
      guint* keyval,
      int* effective_group,
      int* level,
      WPEModifiers* consumed_modifiers
    )

#### Description [src]

Translate `keycode`, `modifiers` and `group` into a keyval, effective group and level. Modifiers that affected the translation are returned in `consumed_modifiers`.

#### Parameters

`keycode`

  Type: `guint`

  A hardware keycode.

`modifiers`

  Type: `WPEModifiers`

  A `WPEModifiers`.

`group`

  Type: `int`

  Active keyboard group.

`keyval`

  Type: `guint*`

  Return location for keyval.

  The argument will be set by the function.
  The argument can be `NULL`.

`effective_group`

  Type: `int*`

  Return location for effective group.

  The argument will be set by the function.
  The argument can be `NULL`.

`level`

  Type: `int*`

  Return location for level.

  The argument will be set by the function.
  The argument can be `NULL`.

`consumed_modifiers`

  Type: `WPEModifiers`

  Return location for modifiers that were used to determine the group or level.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if there was a keyval bound to keycode, modifiers and group, or `FALSE` otherwise.